Bug 681575 (CVE-2011-1082) - CVE-2011-1082 kernel: potential kernel deadlock when creating circular epoll file structures
Summary: CVE-2011-1082 kernel: potential kernel deadlock when creating circular epoll ...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2011-1082
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 681682 681683 681684 681685 681686 681687
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-03-02 16:06 UTC by Petr Matousek
Modified: 2019-09-29 12:43 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-06 07:27:45 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0500 normal SHIPPED_LIVE Important: kernel-rt security and bug fix update 2011-05-10 17:18:23 UTC
Red Hat Product Errata RHSA-2011:0542 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 6.1 kernel security, bug fix and enhancement update 2011-05-19 11:58:07 UTC
Red Hat Product Errata RHSA-2011:0883 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-06-21 23:52:55 UTC

Description Petr Matousek 2011-03-02 16:06:05 UTC
Description of problem:
In several places, an epoll fd can call another file's ->f_op->poll() method
with ep->mtx held. This is in general unsafe, because that other file could
itself be an epoll fd that contains the original epoll fd.

The code defends against this possibility in its own ->poll() method using
ep_call_nested, but there are several other unsafe calls to ->poll elsewhere
that can be made to deadlock. For example, the following simple program causes
the call in ep_insert recursively call the original fd's ->poll, leading to
deadlock


References:
https://lkml.org/lkml/2011/2/5/220
http://seclists.org/oss-sec/2011/q1/337

Upstream commit:
http://git.kernel.org/linus/22bacca48a1755f79b7e0f192ddb9fbb7fc6e64e

Acknowledgements:                                                                                                                                                                            

Red Hat would like to thank Nelson Elhage for reporting this issue.

Comment 4 Eugene Teo (Security Response) 2011-04-11 04:01:45 UTC
Upstream commit:
http://git.kernel.org/linus/22bacca48a1755f79b7e0f192ddb9fbb7fc6e64e

Comment 5 errata-xmlrpc 2011-05-10 17:20:46 UTC
This issue has been addressed in following products:

  MRG for RHEL-5

Via RHSA-2011:0500 https://rhn.redhat.com/errata/RHSA-2011-0500.html

Comment 6 errata-xmlrpc 2011-05-19 11:58:50 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0542 https://rhn.redhat.com/errata/RHSA-2011-0542.html

Comment 8 Eugene Teo (Security Response) 2011-06-14 10:58:06 UTC
Statement:

This issue does not affect the Linux kernel as shipped with Red Hat Enterprise Linux 4 and 5. This was addressed in Red Hat Enterprise Linux 6 and Red Hat Enterprise MRG via https://rhn.redhat.com/errata/RHSA-2011-0542.html and https://rhn.redhat.com/errata/RHSA-2011-0500.html.

Comment 9 errata-xmlrpc 2011-06-21 23:53:15 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6.0.Z - Server Only

Via RHSA-2011:0883 https://rhn.redhat.com/errata/RHSA-2011-0883.html


Note You need to log in before you can comment on or make changes to this bug.